#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
//#include <util/delay.h>
#include "types.h"
#include "config.h"
#include "lib.h"
#include "adc.h"



static uint16_t adc[8];
static uint8_t channel;

void adc_init(void) { 

	memset(adc,0,sizeof(adc));
	ADMUX = 0;
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(0<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
}

void adc_stop(void) {
	ADCSRA = 0;
}


uint16_t getADCVal(uint8 channel) {
	return adc[channel]>>4;
}


ISR(ADC_vect) {   // 11  kHz

	adc[channel] = (adc[channel]*15+(ADC<<2))>>4;
	channel++;
	channel &= 7;

	ADMUX = channel;
	ADCSRA|=(1<<ADSC);
}
